`timescale 1ns / 1ps

module prescaler(CLK, RSCLK, FSMCLK, ADDACLK);
	input CLK;
	output RSCLK;
	output FSMCLK;
	output ADDACLK;
	
	reg divclk;
	reg [7:0]prescale256=0;
	reg [7:0]prescale=0; 				//prescaler (BAUD generator)
	
	always@(posedge CLK)				//div256
		begin
		prescale256<=prescale256+1;
		end
	
	always@(posedge prescale256[1])		//div217
		begin
			prescale <= prescale + 1;
			if (prescale==8'hD8)
				begin
				prescale<=8'h00;
				divclk=1;
				end
			else divclk=0;
		end 

	assign RSCLK=divclk;			//RS232 clk
	assign FSMCLK=prescale256[7];	//FSM
	assign ADDACLK=prescale256[0];	//AD & DA clk

endmodule
